/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Sun Aug 11 14:53:46 CDT 2002
    copyright            : (C) 2002 by Nobuhiro Kuroiwa
    email                : nobu@iastate.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version                                                     *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>

#include "paragui/paragui.h"
#include "paragui/pgapplication.h"
#include "paragui/pgthemewidget.h"
#include "sankakuw.h"

//using namespace std;
//---------------------------------------------------------------------------
//	main()
//	Arguments are necessary for SDL
//---------------------------------------------------------------------------
int main(int argc, char* argv[]) {
	//-----------------------------------------------------------------------
	// every ParaGUI application need an application-object
	//-----------------------------------------------------------------------
	PG_Application app;
	app.SetEmergencyQuit(true);
	//-----------------------------------------------------------------------
    // every application needs a theme (the look & feel of the widgets)
	//-----------------------------------------------------------------------
	app.LoadTheme("default");
	app.InitScreen( 640, 480, 0, SDL_SWSURFACE);
	app.SetCaption( "Sankaku", NULL);
	SankakuWindow sankakuwin;
	if( !sankakuwin.isReady())
	{
		cerr << "SankakuWindow isn't ready" << endl;
		exit( 1);
	}
	//-----------------------------------------------------------------------
	// now we have to make everything visible
	//-----------------------------------------------------------------------
	sankakuwin.show();
	//-----------------------------------------------------------------------
	// Every ParaGUI application is event driven, so we need a loop where
	// we process all events (like mouse handling, keystrokes,...)
	// usually this is done with PG_Application::Run()
	//-----------------------------------------------------------------------
	app.Run();

	return 0;
}

//---------------------------------------------------------------------------
//	Compiler and Linker Options
//---------------------------------------------------------------------------
//	`sdl-config --cflags`  `paragui-config --cflags`  `freetype-config --cflags`
//	`sdl-config --libs`  `paragui-config --libs`  `freetype-config --libs`

//---------------------------------------------------------------------------
//	Add Following scripts in config.in.in
//---------------------------------------------------------------------------
/*dnl ---------------------------------------------------------------
dnl Check for SDL
SDL_VERSION=1.2.5
AM_PATH_SDL($SDL_VERSION,
            :,
            AC_MSG_ERROR([*** SDL version $SDL_VERSION not found!])
)
CFLAGS="$CFLAGS $SDL_CFLAGS"
LIBS="$LIBS $SDL_LIBS"
dnl ---------------------------------------------------------------
dnl ---------------------------------------------------------------
dnl Checks for libraries.
dnl Replace `main' with a function in -lSDL_mixer:
AC_CHECK_LIB(SDL_mixer,
       main,
       LIBS="$LIBS -lSDL_mixer",
       AC_MSG_ERROR([*** SDL_mixer library not found!])
)
dnl ---------------------------------------------------------------
dnl ---------------------------------------------------------------
dnl Checks for libraries.
dnl Replace `main' with a function in -lSGE:
AC_CHECK_LIB(SGE,
       main,
       LIBS="$LIBS -lSGE",
       AC_MSG_ERROR([*** SGE library not found!])
)
dnl ---------------------------------------------------------------
CXXFLAGS="$CXXFLAGS $USE_EXCEPTIONS" dnl __kdevelop[exc]__

*/
