/***************************************************************************
                          projtool.h  -  description
                             -------------------
    begin                : Thu Aug 8 2002
    copyright            : (C) 2002 by Nobuhiro Kuroiwa
    email                : nobu@iastate.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef	PROJTOOL_H
#define	PROJTOOL_H

#include <iostream>
#include <cstdlib>
#include "matrix.h"

class Square
{
public:
	Vec vec[4];
	Square( Vec vec1, Vec vec2, Vec vec3, Vec vec4);
	Square();
	void	assign( Vec vec1, Vec vec2, Vec vec3, Vec vec4);
	bool	iassign(
					unsigned int index,
					NUM_TYPE newx,
					NUM_TYPE newy,
					NUM_TYPE newz
			);
	bool	Square::assign( unsigned int index, Vec &vec_in);
	Vec		&getVec( unsigned int index);
	Square	add( NUM_TYPE in);
	Square	add( NUM_TYPE in_x, NUM_TYPE in_y, NUM_TYPE in_z);
	Square	multiple( Matrix &mat_in); 
};

bool getSquareOnTriangle( NUM_TYPE x0, NUM_TYPE y0, Square &sq);
Square sqcnv2p1(		Square	&sq_in	);
Square sqcnv2p2fromp1(	Square	&sq_in	);
Square sqcnv2p3fromp1(	Square	&sq_in	);
Square sqcnv2p4(		Square	&sq_in	);
Vec cnv2p1(				Vec&	vec_in	);
Vec cnv2p2fromp1(		Vec		&vec_p1	);
Vec cnv2p3fromp1(		Vec		&vec_p1	);
Vec cnv2p4(				Vec		&vec_in	);
Vec cartesian2Spherical(Vec		&vec_in	);
Vec spherical2Mercator(	Vec		&vec_in	);

void initPlanet(
					unsigned int width_triangle,
					unsigned int &height_triangle,
					double resolution
);

Square sqcartesian2Spherical(	Square &sq_in);
Square sqspherical2Mercator(	Square &sq_in);
Square getOuterSquare(			Square &sq_in);

NUM_TYPE getLarger(		NUM_TYPE in_a, NUM_TYPE in_b);
NUM_TYPE getSmaller(	NUM_TYPE in_a, NUM_TYPE in_b);

unsigned int fixPos( unsigned int i_in, unsigned int width);

#endif

